#!/bin/bash

/bin/echo "" > /var/www/html/api/.peerStats.json

DATE=$(date)
PING_1="8.8.8.8"
PING_1_RES=$(ping -qc1 $PING_1 2>&1 | awk -F'/' 'END{ print (/^rtt/? "OK "$5" ms":"FAIL") }')
PING_1_STATUS=$(echo $PING_1_RES | cut -d ' ' -f 1)

/bin/echo -ne '' >  /var/www/html/api/.peerStats.json
/bin/echo -ne '{\n' >>  /var/www/html/api/.peerStats.json
/bin/echo -ne '    "date": "'$DATE'",\n' >>  /var/www/html/api/.peerStats.json

cat /etc/hosts | grep collector | grep -v 127.0.0.1 | awk {'print $2'} | while read peer; do
	PING=$(/bin/ping -c 1 $peer | grep -i -c '1 received')
	if [[ $PING -eq 1 ]]; then
		STATUS='OK'
	else
		STATUS='KO'
	fi
	/bin/echo -ne '    "'$peer'": "'$STATUS'",\n' >>  /var/www/html/api/.peerStats.json
done

/bin/echo -ne '    "dns-a.google.com": "'$PING_1_STATUS'"\n' >> /var/www/html/api/.peerStats.json
/bin/echo -ne '}\n' >>  /var/www/html/api/.peerStats.json

mv /var/www/html/api/.peerStats.json /var/www/html/api/peerStats.json