#!/bin/bash

# ISP Details :  curl -s 'http://ip-api.com/json/81.185.169.244' | jq -r ''
# Get IP : curl -s 'https://api.ipify.org?format=json' | jq -r '.ip'

GET_IP_URL='https://api.ipify.org?format=json'
GET_ISP_URL='http://ip-api.com/json/'
DATE=$(date)
DATE_UNIX=$(date +%s)

PUB_IP=$(/usr/bin/curl --connect-timeout 10 --interface ppp0  -s $GET_IP_URL | /usr/bin/jq -r '.ip')
#PUB_IP=$(/usr/bin/curl -s $GET_IP_URL | jq -r '.ip')

echo $PUB_IP
if [[ $PUB_IP == '' ]]; then
	#void, so no net, set blank
	echo '' > /tmp/.stored_ip
	echo '' > /tmp/.stored_details
	exit 1
else
	#ip is valid
	STORED_IP=$(cat /tmp/.stored_ip 2> /dev/null)
	STORED_DETAILS=$(cat /tmp/.stored_details 2> /dev/null)
	if [[ $STORED_IP == '' ]] || [[ $PUB_IP != $STORED_IP ]] || [[ $STORED_DETAILS == '' ]]; then
		#we've a missmatch, replace stored IP
		# It is time to update ISP as well, we're gonna update API too.

		echo $PUB_IP > /tmp/.stored_ip
		IP_DETAILS=$(/usr/bin/curl --connect-timeout 10 -s $GET_ISP_URL$PUB_IP | /usr/bin/jq -r '')
#		IP_DETAILS=$(/usr/bin/curl -s $GET_ISP_URL$PUB_IP | jq -r '')
		echo $IP_DETAILS > /tmp/.stored_details
	#else
		#ip is the same, do nothing, update API
	#	echo "not coded yet"
	# No need, we're gonna do it everytime
	else
		IP_DETAILS=$(echo $STORED_DETAILS)
	fi

	IP_ISP=$(echo $IP_DETAILS | /usr/bin/jq -r '.isp')
	IP_ORG=$(echo $IP_DETAILS | /usr/bin/jq -r '.org')
	IP_AS=$(echo $IP_DETAILS | /usr/bin/jq -r '.as')
	LOCAL_COUNTRY=$(echo $IP_DETAILS | /usr/bin/jq -r '.country')
	LOCAL_COUNTRY_CODE=$(echo $IP_DETAILS | /usr/bin/jq -r '.countryCode')
	LOCAL_REGION=$(echo $IP_DETAILS | /usr/bin/jq -r '.region')
	LOCAL_REGION_NAME=$(echo $IP_DETAILS | /usr/bin/jq -r '.regionName')
	LOCAL_CITY=$(echo $IP_DETAILS | /usr/bin/jq -r '.city')
	LOCAL_ZIP=$(echo $IP_DETAILS | /usr/bin/jq -r '.zip')
	LOCAL_TZ=$(echo $IP_DETAILS | /usr/bin/jq -r '.timezone')
	LOCAL_GPS_LAT=$(echo $IP_DETAILS | /usr/bin/jq -r '.lat')
	LOCAL_GPS_LON=$(echo $IP_DETAILS | /usr/bin/jq -r '.lon')

	/bin/echo -ne '' > /var/www/html/api/.pubIpInfo.json
	/bin/echo -ne '{\n' >> /var/www/html/api/.pubIpInfo.json
	/bin/echo -ne '    "date": "'$DATE'",\n' >> /var/www/html/api/.pubIpInfo.json
	/bin/echo -ne '    "unix": "'$DATE_UNIX'",\n' >> /var/www/html/api/.pubIpInfo.json
	/bin/echo -ne '    "ip": {\n' >> /var/www/html/api/.pubIpInfo.json
	/bin/echo -ne '        "address": "'$PUB_IP'",\n' >> /var/www/html/api/.pubIpInfo.json
	/bin/echo -ne '        "isp": "'$IP_ISP'",\n' >> /var/www/html/api/.pubIpInfo.json
	/bin/echo -ne '        "org": "'$IP_ORG'",\n' >> /var/www/html/api/.pubIpInfo.json
	/bin/echo -ne '        "as": "'$IP_AS'"\n' >> /var/www/html/api/.pubIpInfo.json
	/bin/echo -ne '    },\n' >> /var/www/html/api/.pubIpInfo.json
	/bin/echo -ne '    "local": {\n' >> /var/www/html/api/.pubIpInfo.json
	/bin/echo -ne '        "country": "'$LOCAL_COUNTRY'",\n' >> /var/www/html/api/.pubIpInfo.json
	/bin/echo -ne '        "countryCode": "'$LOCAL_COUNTRY_CODE'",\n' >> /var/www/html/api/.pubIpInfo.json
	/bin/echo -ne '        "region": "'$LOCAL_REGION'",\n' >> /var/www/html/api/.pubIpInfo.json
	/bin/echo -ne '        "regionName": "'$LOCAL_REGION_NAME'",\n' >> /var/www/html/api/.pubIpInfo.json
	/bin/echo -ne '        "city": "'$LOCAL_CITY'",\n' >> /var/www/html/api/.pubIpInfo.json
	/bin/echo -ne '        "zip": "'$LOCAL_ZIP'",\n' >> /var/www/html/api/.pubIpInfo.json
	/bin/echo -ne '        "timezone": "'$LOCAL_TZ'",\n' >> /var/www/html/api/.pubIpInfo.json
	/bin/echo -ne '        "gps": {\n' >> /var/www/html/api/.pubIpInfo.json
	/bin/echo -ne '            "lat": "'$LOCAL_GPS_LAT'",\n' >> /var/www/html/api/.pubIpInfo.json
	/bin/echo -ne '            "lon": "'$LOCAL_GPS_LON'"\n' >> /var/www/html/api/.pubIpInfo.json
	/bin/echo -ne '        }\n' >> /var/www/html/api/.pubIpInfo.json
	/bin/echo -ne '    }\n' >> /var/www/html/api/.pubIpInfo.json
	/bin/echo -ne '}\n' >> /var/www/html/api/.pubIpInfo.json
	echo "Stored: "$STORED_IP
	echo "Detail: "$STORED_DETAILS

	cat /var/www/html/api/.pubIpInfo.json
	mv /var/www/html/api/.pubIpInfo.json /var/www/html/api/pubIpInfo.json
fi
