#!/bin/bash
#echo -ne '' > /root/data/latency.dat
# @Startup : Clean file
# Keep 3600 lines of data, then remove half of it.
# Make stats for 10s, 30s, 1min, 5, 15 and 30 mins.

## Replace
# /usr/bin/wc -l < /root/data/latency.dat
# /usr/bin/tail -n 1800 /root/data/latency.dat >> /tmp/latency.dat
# mv /tmp/latency.dat /root/data/latency.dat

function getLatencyPerf_init {
        echo -ne '' > /root/api/data/latency.dat
        increment_count=0

        TEN_SEC=0
        THIRTY_SEC=0
        SIXTY_SEC=0
        FIVE_MIN=0
        FIFTEEN_MIN=0
        THIRTY_MIN=0
}

function getLineCount {
        LINECOUNT=$(/usr/bin/wc -l < /root/api/data/latency.dat)
}

function trimOldResults {
        echo -ne '1' > /tmp/latency.dat
        /usr/bin/tail -n 1800 /root/api/data/latency.dat >> /tmp/latency.dat
        mv /tmp/latency.dat /root/api/data/latency.dat
}

function updateAvg {
        TEN_SEC=$(tr \  \\n</root/api/data/latency.dat | /usr/bin/tail -n 10 | /usr/bin/jq -s add/length | /bin/sed s/^/\"avg10s\":\ /)
}

function updateAvgShort {
#        TEN_SEC=$(tr \  \\n</root/api/data/latency.dat | /usr/bin/tail -n 10 | /usr/bin/jq -s add/length | /bin/sed s/^/10s_avg:\ /)
        THIRTY_SEC=$(tr \  \\n</root/api/data/latency.dat | /usr/bin/tail -n 30 | /usr/bin/jq -s add/length | /bin/sed s/^/\"avg30s\":\ /)
        SIXTY_SEC=$(tr \  \\n</root/api/data/latency.dat | /usr/bin/tail -n 60 | /usr/bin/jq -s add/length | /bin/sed s/^/\"avg60s\":\ /)
}

function updateAvgLong {
        FIVE_MIN=$(tr \  \\n</root/api/data/latency.dat | /usr/bin/tail -n 300 | /usr/bin/jq -s add/length | /bin/sed s/^/\"avg5m\":\ /)
        FIFTEEN_MIN=$(tr \  \\n</root/api/data/latency.dat | /usr/bin/tail -n 900 | /usr/bin/jq -s add/length | /bin/sed s/^/\"avg15m\":\ /)
        THIRTY_MIN=$(tr \  \\n</root/api/data/latency.dat | /usr/bin/tail -n 1800 | /usr/bin/jq -s add/length | /bin/sed s/^/\"avg30m\":\ /)
}

function recordLines {
    LATENCY=$(cat /var/www/html/api/lightApi.json | /usr/bin/jq -r '.latency' | cut -d ' ' -f 1)
	if [[ $LATENCY == 'FAIL' ]] || [[ $LATENCY == 'N/A' ]] || [[ $LATENCY == '' ]]; then
		LATENCY='0'
	fi
 	echo $LATENCY >> /root/api/data/latency.dat
}

function getLatencyPerformances {
        if [ $increment_count -gt 60 ]; then
                increment_count=0
                getLineCount
                if [ $LINECOUNT -ge 3600 ]; then
                        trimOldResults
                fi
                updateAvgLong
                updateAvgShort
                updateAvg
        elif (( $increment_count % 30 == 0 )); then
                updateAvgLong
                updateAvgShort
                updateAvg
        elif (( $increment_count % 10 == 0 )); then
                updateAvgShort
                updateAvg
        #elif (( $increment_count % 2 == 0 )); then
        else
                updateAvg
        fi

        ((increment_count=increment_count+1))
        recordLines
}

function constructJSON {
# {
#        "10s_avg": 383.0974,
#        "30s_avg": 309.3297666666668,
#        "60s_avg": 299.5185166666667,
#        "5m_avg": 273.04783606557385,
#        "15m_avg": 273.04783606557385,
#        "30m_avg": 273.04783606557385
#}

	echo -ne '{\n' 			> /var/www/html/api/.la.json
	echo -ne '    '$TEN_SEC',\n' 	>>  /var/www/html/api/.la.json
        echo -ne '    '$THIRTY_SEC',\n'   >>  /var/www/html/api/.la.json
        echo -ne '    '$SIXTY_SEC',\n'    >>  /var/www/html/api/.la.json
        echo -ne '    '$FIVE_MIN',\n'     >>  /var/www/html/api/.la.json
        echo -ne '    '$FIFTEEN_MIN',\n'  >>  /var/www/html/api/.la.json
        echo -ne '    '$THIRTY_MIN'\n'   >>  /var/www/html/api/.la.json
	echo -ne '}\n' 			>> /var/www/html/api/.la.json

	mv -v /var/www/html/api/.la.json /var/www/html/api/rpiLA.json >> /root/logs/latencyAverage.log

#	echo "==.la.json =="
#	cat /var/www/html/api/.la.json
#	mv -v /var/www/html/api/.la.json /var/www/html/api/rpiLA.json >> /root/logs/latencyAverage.log
#	echo -e "#############\n== rpiLA.json =="
#	cat /var/www/html/api/rpiLA.json
#	echo "###############"
#	echo "TEN_SEC":$TEN_SEC
#	echo "THIRTY_SEC":$THIRTY_SEC
}

## Init Stuff
getLatencyPerf_init
trimOldResults

PROCESSFOUND=$(/bin/ps -aux | grep -v 'grep' | grep -v $$ | grep -c '/bin/bash /root/api/rpiLatencyAverage.sh')

#/bin/ps -aux | grep "rpiLatencyAverage.sh" | grep -vc "grep"
#echo "PROCESSFOUND="$PROCESSFOUND
#/bin/ps -aux | grep "rpiLatencyAverage.sh"

if [ $PROCESSFOUND -lt 2 ]
then
        #Not found - need to run it
        getLatencyPerf_init
        trimOldResults

        while [ 42 ]; do
                getLatencyPerformances
                constructJSON
		sleep 1
        done
else
        #Found
	DATE=$(date)
        echo $DATE": Process "$$" is running - Proccess Found "$PROCESSFOUND" times." >> /root/logs/latencyAverage.log
fi
