#!/bin/bash

date +%s > /tmp/.lightning_initDate
date > /root/logs/lightningAPI.log

#sleep 10

OPT=$1
PING_1="8.8.8.8"
PING_2="8.8.4.4"
NET_PERF=$(cat /var/www/html/api/netPerfs.json)
NP_CPU=$(echo $NET_PERF | /usr/bin/jq -r '.cpu')
NP_RAM=$(echo $NET_PERF | /usr/bin/jq -r '.ram')

SERV="Initialization in progress..."
PING_ST="Waiting ppp0 to be bringed up!"
PING_MS="9999 ms"

function commitAPI () {
	DATE_HUM=$(date)
	DATE_UNX=$(date +%s)
	INIT_SEC=$(cat /tmp/.lightning_initDate)
	UPTM_DIF=$((DATE_UNX-INIT_SEC))

	/bin/echo -ne '' > /var/www/html/api/.lightApi.json
	/bin/echo -ne '{\n' >> /var/www/html/api/.lightApi.json
	/bin/echo -ne '    "date": "'$DATE_HUM'",\n' >> /var/www/html/api/.lightApi.json
	/bin/echo -ne '    "unix": '$DATE_UNX',\n' >> /var/www/html/api/.lightApi.json
	/bin/echo -ne '    "uptime": '$UPTM_DIF',\n' >> /var/www/html/api/.lightApi.json
	/bin/echo -ne '    "cpu": '$NP_CPU',\n' >> /var/www/html/api/.lightApi.json
	/bin/echo -ne '    "ram": '$NP_RAM',\n' >> /var/www/html/api/.lightApi.json
	/bin/echo -ne '    "srv": "'$SERV'",\n' >> /var/www/html/api/.lightApi.json
	/bin/echo -ne '    "ping": "'$PING_ST'",\n' >> /var/www/html/api/.lightApi.json
	/bin/echo -ne '    "latency": "'$PING_MS'"\n' >> /var/www/html/api/.lightApi.json
	/bin/echo -ne '}\n' >> /var/www/html/api/.lightApi.json

	if [[ $OPT == 'verbose' ]]; then
		cat /var/www/html/api/.lightApi.json
	fi
	mv -v /var/www/html/api/.lightApi.json /var/www/html/api/lightApi.json >> /root/logs/lightningAPI.log
}

commitAPI

PPP0_IFACE_PRESENT=$( /sbin/ifconfig -v ppp0 | grep inet | awk -F'/' 'END{ print (/inet/? "OK":"FAIL") }')

while [[ $PPP0_IFACE_PRESENT != 'OK' ]]; do
	PPP0_IFACE_PRESENT=$( /sbin/ifconfig -v ppp0 | grep inet | awk -F'/' 'END{ print (/inet/? "OK":"FAIL") }')
	echo -e '\tppp0 - Status: "'$PPP0_IFACE_PRESENT'"' >> /root/logs/lightningAPI.log
	sleep 3
done

echo "Exited waiting for ppp0 loop with value: '"$PPP0_IFACE_PRESENT"'" >> /root/logs/lightningAPI.log
#exit 1

while [ 42 ]; do
	DEBUG=$(cat /root/api/.rpiLightning.debug)

	#NET_PERF=$(/usr/bin/curl --connect-timeout 1 -s http://localhost/api/netPerfs.json)
	NET_PERF=$(cat /var/www/html/api/netPerfs.json)
	NP_CPU=$(echo $NET_PERF | /usr/bin/jq -r '.cpu')
	NP_RAM=$(echo $NET_PERF | /usr/bin/jq -r '.ram')

	SERV=$(echo $PING_1)
	PING_1_RS=$(/bin/ping -qc1 $PING_1 -I ppp0 2>&1 | /usr/bin/awk -F'/' 'END{ print (/^rtt/? "OK "$5" ms":"FAIL") }')
	PING_MS=$(echo $PING_1_RS | cut -d ' ' -f 2-3)
	PING_ST=$(echo $PING_1_RS | cut -d ' ' -f 1)

	if [[ $DEBUG -eq 1 ]]; then
		echo 'Payload A: NetPerf='$NET_PERF', CPU='$NP_CPU', RAM='$NP_RAM', SERV='$SERV', MS='$PING_MS', ST='$PING_ST >> /root/logs/lightningAPI.log
	fi

	commitAPI
	sleep 0.5

	SERV=$(echo $PING_2)
	PING_2_RS=$(/bin/ping -qc1 $PING_2 -I ppp0 2>&1 | /usr/bin/awk -F'/' 'END{ print (/^rtt/? "OK "$5" ms":"FAIL") }')
	PING_MS=$(echo $PING_2_RS | cut -d ' ' -f 2-3)
	PING_ST=$(echo $PING_2_RS | cut -d ' ' -f 1)

	if [[ $DEBUG -eq 1 ]]; then
		echo 'Payload B: NetPerf='$NET_PERF', CPU='$NP_CPU', RAM='$NP_RAM', SERV='$SERV', MS='$PING_MS', ST='$PING_ST >> /root/logs/lightningAPI.log
	fi

	commitAPI
	sleep 0.5
done

#cat .ppp0_stat | grep "tx" | awk '{print $2" "$3" "substr ($10, 1, 1)}'


