#!/bin/bash

PING_1_MS='9999 ms'
PING_1_ST='FAIL'
PING_2_MS='9999 ms'
PING_2_ST='FAIL'

/usr/bin/vnstat -u -i ppp0

while [ 42 ]; do
        /root/api/rpiSystemStatus.sh &
	/usr/bin/vnstat -tr -i ppp0 > /root/.ppp0_stat
	sleep 1

	HOSTNAME=$(hostname)
	SERVER=$HOSTNAME".collector"
	DATE=$(date)
	PING_1="8.8.8.8"
	PING_2="8.8.4.4"
	#PING_1_RES=$(ping -qc1 $PING_1 2>&1 | awk -F'/' 'END{ print (/^rtt/? "OK "$5" ms":"FAIL") }')
	#PING_1_RES=$(ping -qc1 $PING_1 -I ppp0 2>&1 | awk -F'/' 'END{ print (/^rtt/? "OK "$5" ms":"FAIL") }')
	#PING_1_MS=$(echo $PING_1_RES | cut -d ' ' -f 2-3)
	#PING_1_STATUS=$(echo $PING_1_RES | cut -d ' ' -f 1)

	PING_RES=$(cat /var/www/html/api/lightApi.json) # OK
	PING_SRV=$(echo $PING_RES | /usr/bin/jq -r '.srv')
	if [[ $PING_SRV == $PING_1 ]]; then
		PING_1_MS=$(echo $PING_RES | /usr/bin/jq -r '.latency')
		PING_1_ST=$(echo $PING_RES | /usr/bin/jq -r '.ping')
	elif [[ $PING_SRV == "8.8.4.4" ]]; then
		PING_2_MS=$(echo $PING_RES | /usr/bin/jq -r '.latency')
		PING_2_ST=$(echo $PING_RES | /usr/bin/jq -r '.ping')
	else
		PING_1_ST='N/A'
		PING_2_ST='N/A'
	fi

	CPU=$(top -b -n1 | grep "Cpu(s)" | awk '{print $2 + $4}')
	FREE_DATA=`free -m | grep Mem`
	CURRENT=`echo $FREE_DATA | cut -f3 -d' '`
	TOTAL=`echo $FREE_DATA | cut -f2 -d' '`
	RAM=$(echo "scale = 2; $CURRENT/$TOTAL*100" | bc)
	HDD=$(df -lh | awk '{if ($6 == "/") { print $5 }}' | head -1 | cut -d'%' -f1)

	PTX_SPEED=$(cat /root/.ppp0_stat | grep "tx" | awk '{print $2" "$3" "substr ($10, 1, 1)}')
	PTX_PCKTS=$(cat /root/.ppp0_stat | grep "tx" | awk '{print $4" "$5" "substr ($10, 1, 1)}')
	PRX_SPEED=$(cat /root/.ppp0_stat | grep "rx" | awk '{print $2" "$3" "substr ($10, 1, 1)}')
	PRX_PCKTS=$(cat /root/.ppp0_stat | grep "rx" | awk '{print $4" "$5" "substr ($10, 1, 1)}')

	#/bin/echo -ne '\n#### STATS ####\n'
	#/bin/echo -ne 'ppp0 TX Speed: '$PTX_SPEED' - '$PTX_PCKTS'\n'
	#/bin/echo -ne 'ppp0 RX Speed: '$PRX_SPEED' - '$PRX_PCKTS'\n'

	LATENCY_CALL=$(cat /var/www/html/api/rpiLA.json)
	LATENCY_10_SEC=$(echo $LATENCY_CALL | /usr/bin/jq -r '.avg10s')
	LATENCY_30_SEC=$(echo $LATENCY_CALL | /usr/bin/jq -r '.avg30s')
        LATENCY_60_SEC=$(echo $LATENCY_CALL | /usr/bin/jq -r '.avg60s')
        LATENCY_15_MIN=$(echo $LATENCY_CALL | /usr/bin/jq -r '.avg15m')

	/bin/echo -ne '' > /var/www/html/api/.netPerfs.json
	/bin/echo -ne '{\n' >> /var/www/html/api/.netPerfs.json
	/bin/echo -ne '    "date": "'$DATE'",\n' >> /var/www/html/api/.netPerfs.json
	/bin/echo -ne '    "cpu": '$CPU',\n' >> /var/www/html/api/.netPerfs.json
	/bin/echo -ne '    "ram": '$RAM',\n' >> /var/www/html/api/.netPerfs.json
	/bin/echo -ne '    "hdd": '$HDD',\n' >> /var/www/html/api/.netPerfs.json
#	/bin/echo -ne '    "server_1": {\n        "ip": "'$PING_1'",\n        "ms": "'$PING_1_MS'",\n' >> /var/www/html/api/.netPerfs.json
#	/bin/echo -ne '          "status": "'$PING_1_STATUS'"\n    },\n' >> /var/www/html/api/.netPerfs.json
	/bin/echo -ne '    "server_1": {\n        "ip": "'$PING_1'",\n        "ms": "'$PING_1_MS'",\n' >> /var/www/html/api/.netPerfs.json
	/bin/echo -ne '          "status": "'$PING_1_ST'"\n    },\n' >> /var/www/html/api/.netPerfs.json
	/bin/echo -ne '    "server_2": {\n        "ip": "'$PING_2'",\n        "ms": "'$PING_2_MS'",\n' >> /var/www/html/api/.netPerfs.json
	/bin/echo -ne '          "status": "'$PING_2_ST'"\n    },\n' >> /var/www/html/api/.netPerfs.json
	/bin/echo -ne '    "tx": {\n        "speed": "'$PTX_SPEED'",\n' >> /var/www/html/api/.netPerfs.json
	/bin/echo -ne '         "pckts": "'$PTX_PCKTS'"\n    },\n' >> /var/www/html/api/.netPerfs.json
	/bin/echo -ne '    "rx": {\n        "speed": "'$PRX_SPEED'",\n' >> /var/www/html/api/.netPerfs.json
	/bin/echo -ne '         "pckts": "'$PRX_PCKTS'"\n    },\n' >> /var/www/html/api/.netPerfs.json
        /bin/echo -ne '    "latency": {\n        "avg_10s": '$LATENCY_10_SEC',\n' >> /var/www/html/api/.netPerfs.json
        /bin/echo -ne '         "avg_30s": '$LATENCY_30_SEC',\n' >> /var/www/html/api/.netPerfs.json
        /bin/echo -ne '         "avg_60s": '$LATENCY_60_SEC',\n' >> /var/www/html/api/.netPerfs.json
        /bin/echo -ne '         "avg_15m": '$LATENCY_15_MIN'\n    }\n' >> /var/www/html/api/.netPerfs.json
        /bin/echo -ne '}\n' >> /var/www/html/api/.netPerfs.json

	cat /var/www/html/api/.netPerfs.json
	mv /var/www/html/api/.netPerfs.json /var/www/html/api/netPerfs.json
done

#cat .ppp0_stat | grep "tx" | awk '{print $2" "$3" "substr ($10, 1, 1)}'


