#!/bin/bash

## Version pre update
#/usr/bin/speedtest > /root/.speedtest

DATE_H=$(date +"%H")
DATE_HUM=$(date)
DATE_UNX=$(date +%s)

## Speedtest (please uncomment after testing)
#/usr/bin/speedtest > /root/api/data/speedtest
/usr/bin/speedtest --accept-gdpr > /root/api/data/speedtest

## Gather informations
#   Speedtest by Ookla
#
#     Server: Ineside France - Paris (id = 37297)
#        ISP: Orange France Mobile
#    Latency:    34.68 ms   (9.54 ms jitter)
#   Download:     8.90 Mbps (data used: 7.3 MB)
#     Upload:     0.89 Mbps (data used: 1.6 MB)
#  Packet Loss:     0.8%
# Result URL: https://www.speedtest.net/result/c/2fd05dbd-b8f1-4177-be9d-2fdbeb6d8ac4

#SPTST=$(cat /root/api/data/speedtest)
SRV=$(cat /root/api/data/speedtest | grep 'Server:' | cut -d ':' -f 2 | cut -d '(' -f 1 | cut -d ' ' -f 2-6)
ISP=$(cat /root/api/data/speedtest | grep 'ISP:' | cut -d ':' -f 2 | cut -d ' ' -f 2-6)
LAT=$(cat /root/api/data/speedtest | grep 'Latency:' | cut -d ':' -f 2)
LAT_JT=$(echo $LAT | cut -d '(' -f 2 | cut -d ' ' -f 1-2)
LAT_MS=$(echo $LAT | awk '{print $1}')
LAT=$(echo $LAT | awk '{print $1$2}')
DL=$(cat /root/api/data/speedtest | grep 'Download:' | cut -d ':' -f 2-3)
DL_SPEED=$(echo $DL | awk '{print $1}')
DL_SUNIT=$(echo $DL | awk '{print $2}')
DL_SPEED=$(echo $DL_SPEED' '$DL_SUNIT)
DL_USED=$(echo $DL | cut -d ':' -f 2 | cut -d ')' -f 1 | awk '{print $1$2}')
DL_UUNIT=$(echo $DL | cut -d ':' -f 2 | cut -d ')' -f 1 | awk '{print $2}')
DL_USED=$(echo $DL_USED' '$DL_UUNIT)
UP=$(cat /root/api/data/speedtest | grep 'Upload:' | cut -d ':' -f 2-3)
UP_SPEED=$(echo $UP | awk '{print $1}')
UP_SUNIT=$(echo $UP | awk '{print $2}')
UP_SPEED=$(echo $UP_SPEED' '$UP_SUNIT)
UP_USED=$(echo $UP | cut -d ':' -f 2 | cut -d ')' -f 1 | awk '{print $1}')
UP_UUNIT=$(echo $UP | cut -d ':' -f 2 | cut -d ')' -f 1 | awk '{print $2}')
UP_USED=$(echo $UP_USED' '$UP_UUNIT)
PL=$(cat /root/api/data/speedtest | grep 'Packet Loss:' | cut -d ':' -f 2 | awk '{print $1}')
RU=$(cat /root/api/data/speedtest | grep 'Result URL:'  | cut -d ':' -f 2-3 | awk '{print $1}')

#echo 'SRV: '$SRV
#echo 'ISP: '$ISP
#echo 'LAT: '$LAT
#echo -e '\tJit: '$LAT_JT
#echo -e '\tms : '$LAT_MS
#echo 'DL: '$DL
#echo -e '\tSpeed: '$DL_SPEED
#echo -e '\tUsed : '$DL_USED
#echo 'UP: '$UP
#echo -e '\tSpeed: '$UP_SPEED
#echo -e '\tUsed : '$UP_USED
#echo 'PL: '$PL
#echo 'RU: '$RU

## Store Result URL in local data file (for current run)
echo $RU > /root/api/data/.speedtest.$DATE_H

## Gather previous run URLs
RU_00=$(cat /root/api/data/.speedtest.00)
RU_04=$(cat /root/api/data/.speedtest.04)
RU_08=$(cat /root/api/data/.speedtest.08)
RU_12=$(cat /root/api/data/.speedtest.12)
RU_16=$(cat /root/api/data/.speedtest.16)
RU_20=$(cat /root/api/data/.speedtest.20)

/bin/echo -ne '' > /var/www/html/api/.speedTest.json
/bin/echo -ne '{\n' >> /var/www/html/api/.speedTest.json
/bin/echo -ne '    "date": "'$DATE_HUM'",\n' >> /var/www/html/api/.speedTest.json
/bin/echo -ne '    "unix": '$DATE_UNX',\n' >> /var/www/html/api/.speedTest.json
/bin/echo -ne '    "server": "'$SRV'",\n' >> /var/www/html/api/.speedTest.json
/bin/echo -ne '    "isp": "'$ISP'",\n' >> /var/www/html/api/.speedTest.json
/bin/echo -ne '    "latency": "'$LAT'",\n' >> /var/www/html/api/.speedTest.json
/bin/echo -ne '    "latency_ms": '$LAT_MS',\n' >> /var/www/html/api/.speedTest.json
/bin/echo -ne '    "latency_jitter": "'$LAT_JT'",\n' >> /var/www/html/api/.speedTest.json
/bin/echo -ne '    "download": "'$DL_SPEED'",\n' >> /var/www/html/api/.speedTest.json
/bin/echo -ne '    "download_used": "'$DL_USED'",\n' >> /var/www/html/api/.speedTest.json
/bin/echo -ne '    "upload": "'$UP_SPEED'",\n' >> /var/www/html/api/.speedTest.json
/bin/echo -ne '    "upload_used": "'$UP_USED'",\n' >> /var/www/html/api/.speedTest.json
/bin/echo -ne '    "packet_loss": "'$PL'",\n' >> /var/www/html/api/.speedTest.json
/bin/echo -ne '    "result_url": "'$RU'",\n' >> /var/www/html/api/.speedTest.json
/bin/echo -ne '    "result_url_00h": "'$RU_00'",\n' >> /var/www/html/api/.speedTest.json
/bin/echo -ne '    "result_url_04h": "'$RU_04'",\n' >> /var/www/html/api/.speedTest.json
/bin/echo -ne '    "result_url_08h": "'$RU_08'",\n' >> /var/www/html/api/.speedTest.json
/bin/echo -ne '    "result_url_12h": "'$RU_12'",\n' >> /var/www/html/api/.speedTest.json
/bin/echo -ne '    "result_url_16h": "'$RU_16'",\n' >> /var/www/html/api/.speedTest.json
/bin/echo -ne '    "result_url_20h": "'$RU_20'"\n' >> /var/www/html/api/.speedTest.json
/bin/echo -ne '}\n' >> /var/www/html/api/.speedTest.json

date >> /root/logs/speedTest.log
mv -v /var/www/html/api/.speedTest.json /var/www/html/api/speedTest.json >> /root/logs/speedTest.log
