#!/bin/bash

date > /root/logs/rpiSystem.log

TTYUSB=/dev/ttyUSB0
IFCFG_PPP0_AVAIL=$(/sbin/ifconfig -a ppp0 | grep -c ppp0) #must be 1
IFCFG_PPP0_ADDR=$(/sbin/ifconfig -a ppp0 | grep 'inet' | awk '{print $2}')
LSUSB_DONGID=$(/usr/bin/lsusb | grep -i huawei | awk '{print $6}')
LSUSB_DONGLE=$(/usr/bin/lsusb | grep -ic huawei)
LSUSB_SWITCH=$(/usr/bin/lsusb | grep -ic 'Mass storage mode')
CONNECTED=$(cat /var/www/html/api/wvdial.log | grep -ci 'CONNECT')
USINGPPP0=$(cat /var/www/html/api/wvdial.log | grep -ci 'Using interface ppp0')

writeJson() {
	echo -ne '{\n    "Status": "'$1'",\n    "Message": "'$2'"\n}\n' > /var/www/html/api/.systemStatus.json
	mv -v /var/www/html/api/.systemStatus.json /var/www/html/api/systemStatus.json >> /root/logs/rpiSystem.log
}



if [[ -c "$TTYUSB" ]]; then
    echo "$TTYUSB Found!" >> /root/logs/rpiSystem.log
	if [ $LSUSB_DONGLE -eq 1 ]; then
		echo -e "\t$TTYUSB is detected!" >> /root/logs/rpiSystem.log
		writeJson "device found" "Dongle Detected"

		if [ $LSUSB_SWITCH -eq 0 ];then
			echo -e "\t$TTYUSB is not in storage mode!" >> /root/logs/rpiSystem.log
			writeJson "OK" "Not OTG mode"

			if [ $CONNECTED -gt 0 ] && [ $USINGPPP0 -gt 0 ]; then
                        	echo -e "\t$TTYUSB is connected thru ppp0" >> /root/logs/rpiSystem.log
				writeJson "ppp0 connected" "ppp0 connected"
			else
                        	echo -e "\t$TTYUSB is not yet connected!!" >> /root/logs/rpiSystem.log
				writeJson "warning" "ppp0 not yet connected"
			fi
		else
			echo -e "\tWarning! $TTYUSB is in storage mode!" >> /root/logs/rpiSystem.log
			writeJson "warning" "In OTG mode"
		fi
	else
		echo "ERROR! $TTYUSB is not detected in LSUSB!" >> /root/logs/rpiSystem.log
		writeJson "error" "Dongle Not Detected"
	fi
	#### Router Info
	TTYUSB_AVAIL='Available'
else
	TTYUSB_AVAIL='Unavailable'
fi

#### Router Info
if [ $IFCFG_PPP0_AVAIL -eq 1 ]; then PPP0_CONN='Connected'; else PPP0_CONN='Not Connected'; fi
if [ $CONNECTED -gt 0 ]; then WVDIAL_CONN='Connected'; else WVDIAL_CONN='Not Connected'; fi
if [ $USINGPPP0 -gt 0 ]; then WVDIAL_USIN='Unsing PPP0'; else WVDIAL_USIN='Not detected'; fi

echo -ne '{\n' > /var/www/html/api/.routerStatus.json
echo -ne '"ttyUSB0": "'$TTYUSB_AVAIL'",\n' >> /var/www/html/api/.routerStatus.json
echo -ne '"ppp0_connect": "'$PPP0_CONN'",\n' >> /var/www/html/api/.routerStatus.json
echo -ne '"ppp0_inet": "'$IFCFG_PPP0_ADDR'",\n' >> /var/www/html/api/.routerStatus.json
echo -ne '"wvdial_connect": "'$WVDIAL_CONN'",\n' >> /var/www/html/api/.routerStatus.json
echo -ne '"wvdial_ppp0": "'$WVDIAL_USIN'",\n' >> /var/www/html/api/.routerStatus.json
echo -ne '"dongle_ID": "'$LSUSB_DONGID'"\n' >> /var/www/html/api/.routerStatus.json
echo -ne '}\n' >> /var/www/html/api/.routerStatus.json
mv -v /var/www/html/api/.routerStatus.json /var/www/html/api/routerStatus.json >> /root/logs/rpiSystem.log
