#!/bin/bash

# Load network when latency rises up too much (only on active node).
# Every half hour, we're loading up too so we can see if the node is compliant to accept traffic (in case of a rollback)
#
# When throttle is detected on the active node, we're loading for 15 seconds the node.
## If Positive : Okay.
## If Negative : Fallback other node, restart node, check compliance
### If compliant : Fallback again on this node.
### If nor compliant : Stay on the actual node.

RED='\033[0;31m'
LBL='\033[0;34m'
LGR='\033[0;32m'
NC='\033[0m'


A_URL='http://192.168.0.251/api/'
B_URL='http://192.168.0.252/api/'
NC_URL='http://192.168.0.250/api/'

#A_LAPI=$(/usr/bin/curl -s $A_URL'lightApi.json')
#B_LAPI=$(/usr/bin/curl -s $B_URL'lightApi.json')
A_RTRS=$(/usr/bin/curl -s $A_URL'routerStatus.json')
B_RTRS=$(/usr/bin/curl -s $B_URL'routerStatus.json')
NC_RND=$(/usr/bin/curl -s $NC_URL'routerNetData.json')

NR_NODE_A=$(echo $NC_RND | /usr/bin/jq -r '.node_a')
NR_NODE_B=$(echo $NC_RND | /usr/bin/jq -r '.node_b')
NR_NETCORE=$(echo $NC_RND | /usr/bin/jq -r '.netcore')
NR_NETBLCR=$(echo $NC_RND | /usr/bin/jq -r '.netbalancer')

# Active Node
# Save the current mode
# Check that AVG is good
# Check that AVG from other node is correct too

ACTIVE_NODE=$(echo $NR_NETBLCR | /usr/bin/jq -r '.realNode' | cut -d '(' -f 1)
if [[ $ACTIVE_NODE == 'rpi-router-a' ]]; then PASSIVE_NODE='rpi-router-b'; else	PASSIVE_NODE='rpi-router-a';fi

echo 'Active Node '$ACTIVE_NODE
#check if node is healthy

if [[ $ACTIVE_NODE == 'rpi-router-a' ]]; then
	LAST_LT=$(echo $NR_NODE_A | /usr/bin/jq -r '.ms_ping' | cut -d '.' -f 1)

	NET_PRF=$(/usr/bin/curl -s $A_URL'netPerfs.json')
	LATENCY=$(echo $NET_PRF | /usr/bin/jq -r '.latency')
	L_AVG10=$(echo $LATENCY | /usr/bin/jq -r '.avg_10s' | cut -d '.' -f 1)
	L_AVG60=$(echo $LATENCY | /usr/bin/jq -r '.avg_60s' | cut -d '.' -f 1)
	L_AVG15=$(echo $LATENCY | /usr/bin/jq -r '.avg_15m' | cut -d '.' -f 1)

	#echo 'url='$A_URL'netPerfs.json'
	echo 'LAST_LT: '$LAST_LT
        echo 'L_AVG10: '$L_AVG10
        echo 'L_AVG60: '$L_AVG60
        echo 'L_AVG15: '$L_AVG15

	LAT_AVG=$(echo $(((L_AVG10+L_AVG60+L_AVG15)/3)))
	echo 'LAT_AVG: '$LAT_AVG
	#if [ $LAST_LT -gt 200 ]; then
		#Unheathy Node
	#else
		#Healthy Node
	#fi
fi
