#!/bin/bash

NBRUNNER_PROCESS=$(ps -aux | grep '/bin/bash /root/runners/lifeCycleManager.sh runner' | grep -vc "grep")

show_help () {
        echo "no param or runner -> runner"
        exit 1
}

callbackStatus () {
        /usr/bin/curl -s $API_OPT'&service='$R_SVC'&action='$R_ACT'&status='$1
}

if [[ $1 == '' ]]; then
        #default runner - Wrapper
        if [[ $NBRUNNER_PROCESS -lt 1 ]]; then
                /root/runners/lifeCycleManager.sh runner &
        else
                DATE=$(date) # >> /root/logs/lifeCycle.log
                echo $DATE" [Runner] Runner is already running" >> /root/logs/lifeCycle.log
        fi
elif [[ $1 == 'runner' ]]; then
        #here we want to run the lifeCycle with defined options
        #LIFECYCLE_PROCESS=$(ps -aux | grep '/bin/bash /root/routing/lifeCycle.sh' | grep -vc "grep")

        #sleep 1
        #if [[ $LIFECYCLE_PROCESS -lt 1 ]]
        #then

        HOSTNAME=$(hostname)
        API_ROOT='http://192.168.0.250/api/'
        API_ACT=$(echo $API_ROOT'action/poma_'$HOSTNAME'.req')
        API_OPT=$(echo $API_ROOT'powerManager.php?node='$HOSTNAME)

        echo 'Hostname: '$HOSTNAME
        echo 'ACT: '$API_ACT
        echo 'OPT: '$API_OPT

        IS_UNKNOWN_HOST=$(/usr/bin/curl -s $API_ACT | grep -c 'pihole/blockingpage.css')
        echo 'INIT?: '$IS_UNKNOWN_HOST


        if [[ $IS_UNKNOWN_HOST -eq 1 ]]; then
                /usr/bin/curl -s $API_OPT'&status=init'
		rm /etc/poma_commands
                /usr/bin/wget $API_ROOT'poma_commands' -P /etc/
        fi

        #Once inited, we can read propreties from the API and the requests
        # Workflow :
        ## pending : Pending client to read the request
        ## recieved : client read the request
        ## processed: client executed the request (END)


        while [ 42 ]; do
                # possible actions requested
                RJSON=$(/usr/bin/curl -s $API_ACT)
                R_STS=$(echo $RJSON | /usr/bin/jq -r '.status')

                if [[ $R_STS == 'pending' ]] || [[ $R_STS == 'recieved' ]]; then
                        R_SVC=$(echo $RJSON | /usr/bin/jq -r '.service')
                        R_ACT=$(echo $RJSON | /usr/bin/jq -r '.action')

                        echo 'Service: '$R_SVC >> /root/logs/lifeCycle.log
                        echo 'Action : '$R_ACT >> /root/logs/lifeCycle.log

                        if [ $R_SVC == '' ] || [ $R_ACT == '' ]; then
                                echo "One or more option is empty, archiving request..." >> /root/logs/lifeCycle.log
                        else
                                # Executing
                                echo "Parameters are looking good, working on the request..."
                                /usr/bin/curl -s $API_OPT'&service='$R_SVC'&action='$R_ACT'&status=recieved'

                                # REQUEST PARSING
                                REQ_P=$(cat /etc/poma_commands | grep -i $R_SVC | grep -i $R_ACT)
                                IS_SVC_FOUND=$(echo $REQ_P | grep -c -i $R_SVC)
                                IS_ACT_FOUND=$(echo $REQ_P | grep -c -i $R_ACT)

                                if [ $IS_SVC_FOUND -ge 1 ] && [ $IS_ACT_FOUND -ge 1 ]; then
                                        COMM_1=$(echo $REQ_P | /usr/bin/cut -d ';' -f 2)
                                        COMM_2=$(echo $REQ_P | /usr/bin/cut -d ';' -f 3)

                                        echo 'Command 1: '$COMM_1 >> /root/logs/lifeCycle.log
                                        echo 'Command 2: '$COMM_2 >> /root/logs/lifeCycle.log
                                        # REQUEST EXECUTING
                                        $COMM_1
                                        $COMM_2
                                        #callback_status='processed'
                                        callbackStatus 'processed'
                                else
                                        #callback_status='command_not_found'
                                        callbackStatus 'command_not_found'
                                fi

                                # Sending update on the request
                                #/usr/bin/curl -s $API_OPT'&service='$R_SVC'&action='$R_ACT'&status='$callback_status
                        fi
                ## Add debug option maybe ?
                #else
                #        echo "Request must be completed or missing | status: "$R_STS >> /root/logs/lifeCycle.log
                fi
                sleep 1
        done
        #fi
elif [[ $1 == 'help' ]]; then
        show_help
elif [[ $1 == 'show' ]]; then
        RJSON=$(/usr/bin/curl -s $API_ACT)
        R_STS=$(echo $RJSON | /usr/bin/jq -r '.status')
        R_SVC=$(echo $RJSON | /usr/bin/jq -r '.service')
        R_ACT=$(echo $RJSON | /usr/bin/jq -r '.action')

        if [[ $2 == 'service' ]]; then
                echo 'Service: '$R_SVC
        elif [[ $2 == 'action' ]]; then
                echo 'Action: '$R_ACT
        elif [[ $2 == 'all' ]] || [[ $2 == '' ]]; then
                echo -e 'Service: '$R_SVC'\nAction: '$R_ACT'\nStatus: '$R_STS
        else
                RET="options: service, action, all"
        fi
elif [[ $1 == 'status' ]]; then
        echo "Runners:"
        ps -aux | grep lifeCycleManager.sh | grep -v grep
elif [[ $1 == 'stop' ]]; then
        PCS=$(ps -aux | grep '/bin/bash /root/runners/lifeCycleManager.sh runner' | grep -v grep | awk '{print $2}')
        echo "Procs: "$PCS
        kill -9 $PCS
fi


