#!/bin/bash

NBRUNNER_PROCESS=$(ps -aux | grep '/bin/bash /root/runners/netBalancerRunner.sh runner' | grep -vc "grep")

show_help () {
	echo "no param or runner -> runner"
	echo "config OPT1 OPT2   -> config"
	/root/routing/netBalancer.sh help
	exit 1
}

#Options : 
# Fallback A/B
# Distributed None
# Last Option can be force (or no check).

if [[ $1 == '' ]]; then
	#default runner - Wrapper
	if [[ $NBRUNNER_PROCESS -lt 1 ]]; then
		/root/runners/netBalancerRunner.sh runner &
	else
		DATE=$(date) # >> /root/logs/netBalancer.log
		echo $DATE" [Runner] Runner is already running" >> /root/logs/netBalancer.log
	fi
elif [[ $1 == 'runner' ]]; then
	#here we want to run the netBalancer with defined options
	NETBALANCE_PROCESS=$(ps -aux | grep '/bin/bash /root/routing/netBalancer.sh' | grep -vc "grep")

	sleep 1
	if [[ $NETBALANCE_PROCESS -lt 1 ]]
	then

	while [ 42 ]; do
		WEBCONFIG=$(cat /var/www/html/api/action/netBalancerMode.cnf)

		if [[ $WEBCONFIG != '' ]]; then
			# we have a conf
			WEBCONF_MODE=$(echo $WEBCONFIG | jq -r '.mode')
			WEBCONF_NODE=$(echo $WEBCONFIG | jq -r '.node')

			if [[ $WEBCONF_MODE == 'distributed' ]]; then
				echo 'distributed' > /root/routing/.netBalancer/runner_mode
			else
				echo 'fallback '$WEBCONF_NODE > /root/routing/.netBalancer/runner_mode
			fi
			echo '' > /var/www/html/api/action/netBalancerMode.cnf
		fi

		#statements
		USING_MODE=$(cat /root/routing/.netBalancer/runner_mode)
		if [[ $USING_MODE == '' ]]; then
			USING_MODE='fallback a'
		fi
		/root/routing/netBalancer.sh $USING_MODE --silence &
		sleep 2
	done
		#echo "NOT FOUND"
	#else
	#       echo "PROCESS FOUND"
	fi
elif [[ $1 == 'help' ]]; then
	show_help
elif [[ $1 == 'config' ]]; then
	if [[ $2 == '' ]]; then
		show_help
	elif [[ $2 == 'fallback' ]]; then
		#fallback mode
		if [[ $3 == 'a' ]] || [[ $3 == 'b' ]]; then
			SELECT=$(echo ' '$3)
		else
			SELECT=''
		fi
		echo 'fallback'$SELECT > /root/routing/.netBalancer/runner_mode
	elif [[ $2 == 'distributed' ]]; then
		#distributed mode
		echo 'distributed' > /root/routing/.netBalancer/runner_mode
	fi
elif [[ $1 == 'show' ]]; then
	if [[ $2 == 'mode' ]]; then
		RET=$(cat /root/routing/.netBalancer/mode)
	elif [[ $2 == 'node' ]] || [[ $3 == 'using_node' ]]; then
		RET=$(cat /root/routing/.netBalancer/using_node)
	elif [[ $2 == 'all' ]]; then
		RET=$(cat /root/routing/.netBalancer/using_node /root/routing/.netBalancer/runner_mode)
	else
		RET="options: mode, node, all"
	fi
	echo $2': '$RET
elif [[ $1 == 'status' ]]; then
	echo "Runners:"
	ps -aux | grep netBalancerRunner.sh | grep -v grep
	echo "NetBalancer:"
	ps -aux | grep netBalancer.sh | grep -v grep

elif [[ $1 == 'stop' ]]; then
	PCS=$(ps -aux | grep '/bin/bash /root/runners/netBalancerRunner.sh runner' | grep -v grep | awk '{print $2}')
	echo "Procs: "$PCS
	kill -9 $PCS
fi
